<template>
  <div class="flex flex-col items-center" id="habit-statistics">
    <div
      class="w-full flex justify-center text-white"
      style="margin-top: 70px;"
    >
      <div class="text-center px-5">
        <p>Tổng ngày</p>
        <p class="text-4xl">{{ totalDays }}</p>
      </div>
      <div class="text-center px-5">
        <p>Streak dài nhất</p>
        <p class="text-4xl">{{ longestStreak }}</p>
      </div>
      <div class="text-center px-5">
        <p>Streak hiện tại</p>
        <p class="text-4xl">{{ currentStreak }}</p>
      </div>
    </div>

    <Datepicker
      class="mt-8"
      inline
      :highlighted="highlightedFn"
      :disabledDates="disabledDates"
    ></Datepicker>

    <!-- TO DO SOMETHING -->

    <div class="absolute top-0 left-0 pl-5 text-white">
      <div class="flex items-center mt-4 ">
        <h4
          class="p-2 rounded-full cursor-pointer flex"
          style="background-color: rgba(0, 0, 0, 0.1)"
          @click.stop="$emit('close')"
        >
          <feather-icon
            icon="ChevronsLeftIcon"
            svgClasses="h-7 w-7 text-white"
          />
        </h4>
        <p class="text-3xl ml-5">{{ this.selectedHabit.name }}</p>
      </div>
    </div>
  </div>
</template>

<script>
import {
  now,
  isSameDay,
  getLogestStreak,
  getCurrentStreak
} from "../../core/utils/date";
import { groupBy } from "../../core/utils/list";
import moment from "moment";
import Datepicker from "vuejs-datepicker";

export default {
  components: {
    Datepicker
  },

  props: {
    selectedHabit: { type: Object, require: true }
  },

  computed: {
    habitProgressDays() {
      const list = (this.selectedHabit.habitProgress || []).slice();

      // group an array of objects (or subarrays) through a key
      const groupsList = Object.values(
        groupBy(list, item => moment(item.date).format("YYYY-MM-DD"))
      );

      return groupsList.map(group =>
        moment(group[0].date).format("YYYY-MM-DD")
      );
    },

    totalCheckIns() {
      let total = 0;
      (this.selectedHabit.habitProgress || []).forEach(log => {
        if (isSameDay(log.date, Date(now()))) {
          total += log.current;
        }
      });
      return total;
    },

    progressPercent() {
      return (this.totalCheckIns / this.selectedHabit.missionDayTarget) * 100;
    },

    totalDays() {
      let total = 0;

      const list = (this.selectedHabit.habitProgress || []).slice();

      // group an array of objects (or subarrays) through a key
      const groupsList = Object.values(
        groupBy(list, item => moment(item.date).format("YYYY-MM-DD"))
      );

      // const result = groupsList.map(group => ({
      //   value: moment(group[0].date).format("YYYY-MM-DD"), // get key
      //   data: group
      // }));

      return groupsList.length;
    },

    highlightedFn() {
      const list = this.habitProgressDays.map(date => new Date(date));
      return {
        // Highlight an array of dates
        dates: list,
        includeDisabled: true // Highlight disabled dates
        // customPredictor(date) {
        //   const f_date = moment(date).format("YYYY-MM-DD");
        //   // this??? => failed
        //   if (this.habitProgressDays.includes(f_date)) {
        //     return true;
        //   }
        // }
      };
    },

    disabledDates() {
      const freqInfo = this.selectedHabit.frequency;
      if (freqInfo.typeFrequency == "daily")
        // return {
        //   days: freqInfo.dailyDays // => not friendly
        // };
        return {
          // be careful => need get context *this with arrow function
          customPredictor: date => {
            const isActive = this.habitProgressDays.includes(
              moment(date).format("YYYY-MM-DD")
            );
            if (freqInfo.dailyDays.includes(date.getDay()) && !isActive) {
              return true;
            }
          }
        };

      if (freqInfo.typeFrequency == "weekly")
        return {
          // be careful => need get context *this with arrow function
          customPredictor: date => {
            const isActive = this.habitProgressDays.includes(
              moment(date).format("YYYY-MM-DD")
            );
            // disables the date if it is a multiple of ${freqInfo.weeklyDays}
            if (date.getDate() % freqInfo.weeklyDays == 0 && !isActive) {
              return true;
            }
          }
        };

      // if (freqInfo.typeFrequency == "interval") return {}
      return {};
    },

    longestStreak() {
      const list = this.habitProgressDays.slice();
      // const array = list.map(date => new Date(date));
      return getLogestStreak(list);
    },

    currentStreak() {
      const list = this.habitProgressDays.slice();
      return getCurrentStreak(list);
    }
  }
};
</script>

<style lang="scss">
#habit-statistics {
  // p {
  //   color: white;
  // }
}
</style>
